var GpioFeature =function(){
    this._intializedGpios = { };
    this._gpioTriggered = { };
    this._scorezoneHits = { };
    // this._scorezoneTimeouts = { };
};

GpioFeature.prototype._initializeGpioOut = function(pinnumber) {
    if (this._initializeGpioOut[pinnumber] !== undefined) return false;

    var execGpio = require("child_process").exec;
    execGpio('echo "' + pinnumber + '" > /sys/class/gpio/export && echo "out" > /sys/class/gpio/gpio' + pinnumber + '/direction');
    console.log('GPIO' + pinnumber + ' initialized...');
    this._initializeGpioOut[pinnumber] = true;
    this._gpioTriggered[pinnumber] = false;

    return true;
}

GpioFeature.prototype.setState = function(pinnumber, high) {
    this._initializeGpioOut(pinnumber);
    if (high && this._gpioTriggered[pinnumber]) {
        execGpio('echo 1 > /sys/class/gpio/gpio' + pinnumber + '/value');
        this._gpioTriggered[pinnumber] = true;
        return true;
    } else if (this._gpioTriggered[pinnumber]) {
        execGpio('echo 0 > /sys/class/gpio/gpio' + pinnumber + '/value');
        this._gpioTriggered[pinnumber] = false;
        return true;
    }
    return false;
}
/**
 * scorezone.gpio = { pin: 20, hits: 10, timeoutOn: 1000 }
 * 
 * @param {*} scorezone 
 */
GpioFeature.prototype.triggerByZone = function(scorezone) {
    if (scorezone.gpio === undefined) return;
    
    var pin = scorezone.gpio.pin;
    var score = scorezone.score;
    var self = this;

    if (scorezone.gpio.hits !== undefined) {
        if (this._scorezoneHits[score] === undefined) this._scorezoneHits[score] = 0;
        if (++this._scorezoneHits[score] == scorezone.gpio.hits) {
            this.setState(pin, true);
            // turn off after X milliseconds
            setTimeout(function() { 
                self.setState(pin, false);
            }, scorezone.gpio.timeoutOn);
            // reset everything after X milliseconds
            setTimeout(function() { 
                self._scorezoneHits = { };
            }, scorezone.gpio.timeoutOff);
            // if (scorezone.gpio.timeoutHit !== undefined) {
            //     if (this._scorezoneTimeouts[score] !== undefined) {
            //         clearTimeout(this._scorezoneTimeouts[score]);
            //     }
            //     this._scorezoneTimeouts[score] = setTimeout()
            // }
        }
    }

}

module.exports = new GpioFeature();