# $Revision: 2832 $ $Date: 2020-10-23 10:54:40 -0300 (Fri, 23 Oct 2020) $
# $HeadURL: http://support2.silvermountaintargets.com/svn/smt/create_images/extract_software_patch.sh $
# $Id: extract_software_patch.sh 2832 2020-10-23 13:54:40Z dmc $

# echo hi from software_patch.sh CMD=${CMD} filename=${filename}


# are there architecture limitations for this patch?

eval ${TAR_CMD} target_arch.sh  >/dev/null 2>/dev/null && {
	echo about to source target_arch.sh, check for architecture restrictions
	. ./target_arch.sh
	# trimslice: armv7l
	# Carambola2: mips
	# PCEngines: x86_64
	MY_ARCH=`uname -m`
	[ -n "${TARGET_ARCH}" -a "${MY_ARCH}" != "${TARGET_ARCH}" ] && {
		echo "Incompatible architecture ${MY_ARCH}, patch intended for ${TARGET_ARCH}"
		leave 1
	}
}



production=1
# production=""
rootdir_for_patch=""

[ -n "${production}" ] && {
	rootdir_for_patch_filename="ROOTDIR_FOR_PATCH"
	echo "checking for ${rootdir_for_patch_filename}"
	${TAR_CMD} ${rootdir_for_patch_filename} 2>/dev/null >/dev/null
	[ -z "${rootdir_for_patch}" -a -s "${rootdir_for_patch_filename}" ] && { #file exists and size nonzero
		rootdir_for_patch="`cat ${rootdir_for_patch_filename}`"
	}

	trydir="/home/smt/SilverMountainTargets" # S10/trimslice
	[ -z "${rootdir_for_patch}" -a -d "${trydir}" ] && {
		rootdir_for_patch="${trydir}"
	}
	trydir="/www/smtv2" # G2/SOLO/S25/S7
	[ -z "${rootdir_for_patch}" -a -d "${trydir}" ] && {
		rootdir_for_patch="${trydir}"
	}
}

[ -z "${production}" ] && {
	rm -rf /tmp/dir2
	mkdir /tmp/dir2
	rootdir_for_patch="/tmp/dir2"
}

echo production=${production}, rootdir_for_patch=${rootdir_for_patch}

cd "${rootdir_for_patch}"
eval ${TAR_CMD}
chown -R `id -u`:`id -g` . 2>/dev/null # don't show error "cannot chown public/backup.tgz"

echo "patch files applied to `pwd`"

# TODO: detect system type (S25, G2 etc) and don't apply if incompatible
